/*
    This source code contains routines to manipulate
    GameBoy ROM images.  It is meant that source to be used
    as a learning tool and not a tool of piracy.

    *BorlandC 3.1 was used to compile this successfully.

    It is a crime to redistribute these routines in a commercial
    venture of any kind without permission or licensing agreement.
    Contact us at our web page for more information on licensing.

    (C)opyright 1995,96 Damaged Cybernetics

    If you have any questions or comments, please contact the
     following ppl via the Internet:

    Donald Moore   (MindRape) mindrape@goodnet.com
    Donald Staheli (Royce)     staheli@goodnet.com

    Web Page: www.futureone.com/~damaged

    Things that still need to be done is to calculate the compliment of
    the GameBoy ROM image.

 */

/* standard true/false declarations */
#define TRUE  1
#define FALSE 0


/* size of our file buffers */
#define BUFFER_SIZE 4096


/* size of standard GameBoy copier headers */
#define HEADER_SIZE 512


/* location of GameBoy CheckSum offsets */
#define GB_CHECKSUM_OFFSET1 0x14E
#define GB_CHECKSUM_OFFSET2 0x14F


/* definitions for gameboy detection */
#define DETECT_GAMEBOY_BUFFER_SIZE 1024             /* bit big oh well, 512 is for possible header */

#define DETECT_GAMEBOY_INVALID        0             /* Invalid GameBoy Image, failed check         */
#define DETECT_GAMEBOY_HEADER         1             /* game has some kind of header, (SWC or FIG)  */
#define DETECT_GAMEBOY_RAW            2             /* game has NO kind of header                  */


#define DETECT_GAMEBOY_MAJIC_HEADR_POS  0x304       /* possible position if header                 */
#define DETECT_GAMEBOY_MAJIC_RAW_POS    0x104       /* possible position without header            */
#define DETECT_GAMEBOY_MAJIC_SIZE          48       /* GameBoy signature is 48 bytes               */


/* prototypes */
    void     PutGBCheckSum(FILE *source,unsigned int uiCheckSum);
unsigned int GetGBCheckSum(FILE *source,unsigned int uiOffset);
unsigned int CalculateGBCheckSum(FILE *source,unsigned int uiOffset);
unsigned int swapint(unsigned int uiValue);
        char DetectGameBoy(FILE *source);

